//************************************************************************************
//*                                                                                  *
//* This document contains programming examples.                                     *
//*                                                                                  *
//* Custom Engineering grants you a nonexclusive copyright license to use            *
//* all programming code examples from which you can generate similar                *
//* function tailored to your own specific needs.                                    *
//*                                                                                  *
//* All sample code is provided by Custom Engineering for illustrative purposes      *
//* only. These examples have not been thoroughly tested under all conditions.       *
//* Custom Engineering, therefore, cannot guarantee or imply reliability,            *
//* serviceability, or function of these programs.                                   *
//*                                                                                  *
//* In no event shall Custom Engineering be liable for any direct, indirect,         *
//* incidental, special, exemplary, or consequential damages (including, but not     *
//* limited to, procurement of substitute goods or services; loss of use, data,      *
//* or profits; or business interruption) however caused and on any theory of        *
//* liability, whether in contract, strict liability, or tort (including negligence  *
//* or otherwise) arising in any way out of the use of this software, even if        *
//* advised of the possibility of such damage.                                       *
//*                                                                                  *
//* All programs contained herein are provided to you "as is" without any            *
//* warranties of any kind.                                                          *
//* The implied warranties of non-infringement, merchantability and fitness for a    *
//* particular purpose are expressly disclaimed.                                     *
//*                                                                                  *
//************************************************************************************

package it.custom.powertool.demo.android.printtool;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

import android.content.Context;
import android.content.res.Resources.NotFoundException;

public class CustomFile {

	
	public static void copy(File src, File dst) throws IOException {
        InputStream in = new FileInputStream(src);
        OutputStream out = new FileOutputStream(dst);

        // Transfer bytes from in to out
        byte[] buf = new byte[1024];
        int len;
        while ((len = in.read(buf)) > 0) {
            out.write(buf, 0, len);
        }
        in.close();
        out.close();
    }
    
    public static void copy(Context context, int srcResourceId, File dst) throws IOException {
        InputStream in;
        try {
            in = context.getResources().openRawResource(srcResourceId);
            }
            catch(NotFoundException e){
            	e.printStackTrace();
            	return;
            }
        
        
        OutputStream out = new FileOutputStream(dst);

        // Transfer bytes from in to out
        byte[] buf = new byte[1024];
        int len;
        while ((len = in.read(buf)) > 0) {
            out.write(buf, 0, len);
        }
        in.close();
        out.close();
    }
    
    public static void copyFromAssets(Context context, String name, File dst) throws IOException {
        InputStream in;
        try {
            in = context.getAssets().open(name);
            }
            catch(NotFoundException e){
            	e.printStackTrace();
            	return;
            }
        
        
        OutputStream out = new FileOutputStream(dst);

        // Transfer bytes from in to out
        byte[] buf = new byte[1024];
        int len;
        while ((len = in.read(buf)) > 0) {
            out.write(buf, 0, len);
        }
        in.close();
        out.close();
    }
    
    

    
}

