//************************************************************************************
//*                                                                                  *
//* This document contains programming examples.                                     *
//*                                                                                  *
//* Custom Engineering grants you a nonexclusive copyright license to use            *
//* all programming code examples from which you can generate similar                *
//* function tailored to your own specific needs.                                    *
//*                                                                                  *
//* All sample code is provided by Custom Engineering for illustrative purposes      *
//* only. These examples have not been thoroughly tested under all conditions.       *
//* Custom Engineering, therefore, cannot guarantee or imply reliability,            *
//* serviceability, or function of these programs.                                   *
//*                                                                                  *
//* In no event shall Custom Engineering be liable for any direct, indirect,         *
//* incidental, special, exemplary, or consequential damages (including, but not     *
//* limited to, procurement of substitute goods or services; loss of use, data,      *
//* or profits; or business interruption) however caused and on any theory of        *
//* liability, whether in contract, strict liability, or tort (including negligence  *
//* or otherwise) arising in any way out of the use of this software, even if        *
//* advised of the possibility of such damage.                                       *
//*                                                                                  *
//* All programs contained herein are provided to you "as is" without any            *
//* warranties of any kind.                                                          *
//* The implied warranties of non-infringement, merchantability and fitness for a    *
//* particular purpose are expressly disclaimed.                                     *
//*                                                                                  *
//************************************************************************************

package it.custom.powertool.demo.android.printtool;

import it.custom.printer.api.android.CustomAndroidAPI;
import it.custom.printer.api.android.CustomException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Spinner;
import android.widget.AdapterView.OnItemSelectedListener;



public class CustomOnItemDevTypeSelectedListener implements OnItemSelectedListener {

	private Context context;
	private Spinner spinnerDevice;
	public static boolean onRestore = false;
	public static int onRestoreCounter = 0;
	public static int onRestoreChildPos = -1;

	
	CustomOnItemDevTypeSelectedListener(Context ctx, Spinner sp )
	{
		super();
		context = ctx;
		spinnerDevice = sp;				
	}
	
  @Override
  public void onItemSelected(AdapterView<?> parent, View view, int pos,long id) {

	  boolean restoring = false;
	  if ( onRestore)
	  {
		  restoring=true;
		  onRestoreCounter++;
		  if ( (onRestoreCounter>=2) || (pos==0))
		  {
			  onRestore=false;
			  onRestoreCounter=0;
		  }		  
	  }
	  
	  MainActivity.deviceSelected=-1;
	  MainActivity.deviceType=pos;
	  
	//SetParamsFromProject(parent.getItemAtPosition(pos).toString()); 
	  if ( pos==1)
		  SelectTypeEthernet(restoring);
	  else if ( pos==2)
		  SelectTypeBlueTooth(restoring);
	  else if ( pos==3)
		  SelectTypeUsb(restoring);
	  else 
		  SelectTypeNone(restoring);
	  
	  if ( (restoring) && (!onRestore) && (onRestoreChildPos!=-1) )
		  spinnerDevice.setSelection(onRestoreChildPos);
  }
 
  
  @Override
  public void onNothingSelected(AdapterView<?> arg0) {
	// TODO Auto-generated method stub
  }
 
  private void SelectTypeNone(boolean restore)
  { 
	    List<String> list = new ArrayList<String>();
		ArrayAdapter<String> dataAdapter = new ArrayAdapter<String>(context,android.R.layout.simple_spinner_item, list);
	  	dataAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);	  	
	  	spinnerDevice.setAdapter(dataAdapter);
  }
  
 private void SelectTypeEthernet(boolean restore)
 { 	
		try
        {
        	//Get the list of devices (search for 1.5 seconds)
			if (!restore)
				MainActivity.ethDeviceList = CustomAndroidAPI.EnumEthernetDevices(1500, context);
			
        	if ((MainActivity.ethDeviceList == null) || (MainActivity.ethDeviceList.length == 0))
        	{
        		//Show Error
        		showAlertMsg("Error...", "No Devices Connected...");                		
        	
        	}                               	
        }
		catch(CustomException e )
        {
			MainActivity.ethDeviceList = null;
        	//Show Error
        	showAlertMsg("Error...", e.getMessage());
    	
        }
        catch(Exception e )
        {
        	MainActivity.ethDeviceList = null;
        	//Show Error
        	showAlertMsg("Error...", "Enum devices error...");
    
        }
		
		if (MainActivity.ethDeviceList == null)
		{
			MainActivity.ethDeviceList = new String[0];
		}
		
	  	MainActivity.deviceSelected=-1;
		ArrayAdapter<String> dataAdapter = new ArrayAdapter<String>(context,android.R.layout.simple_spinner_item, MainActivity.ethDeviceList);
	  	dataAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);	  	
	  	spinnerDevice.setAdapter(dataAdapter);
	  	spinnerDevice.setOnItemSelectedListener(new CustomOnItemDeviceSelectedListener());
	  		  		  	 
	  	 
 }
	


 private void SelectTypeBlueTooth(boolean restore)
 {
 
	//If is the 1st time
	  	    	    	    		
	try
	{
	 	//Get the list of devices 
		if (!restore)
			MainActivity.btDeviceList = CustomAndroidAPI.EnumBluetoothDevices();
			
	 	if ((MainActivity.btDeviceList == null) || (MainActivity.btDeviceList.length == 0))
	 	{
	 		//Show Error
	 		showAlertMsg("Error...", "No Devices Connected...");                		
	 	
	 	}                               	
	 }
	 catch(CustomException e )
	 {
		MainActivity.btDeviceList = null;
	 	//Show Error
	 	showAlertMsg("Error...", e.getMessage());
	
	 }
	 catch(Exception e )
	 {
		 MainActivity.btDeviceList = null;
	 	//Show Error
	 	showAlertMsg("Error...", "Enum devices error...");
	
	 }            
	
	 String[] strDevices;
	if (MainActivity.btDeviceList == null)
	{
		strDevices = new String[0];
	}
	else
	{

        // Create and populate a List of Devices
		strDevices = new String[MainActivity.btDeviceList.length];
		 for (int i=0;i<MainActivity.btDeviceList.length;i++)
		 {
		 	strDevices[i] = (i+1)+". BT Device : " + MainActivity.btDeviceList[i].getName();	            	
		 }
        

	}
	    	
    ArrayList<String> devicesList = new ArrayList<String>();  
    devicesList.addAll( Arrays.asList(strDevices) );  
  	
	ArrayAdapter<String> dataAdapter = new ArrayAdapter<String>(context,android.R.layout.simple_spinner_item, devicesList);
  	dataAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);	  	
  	spinnerDevice.setAdapter(dataAdapter);
  	spinnerDevice.setOnItemSelectedListener(new CustomOnItemDeviceSelectedListener());
   
 }
 
 private void SelectTypeUsb(boolean restore)
 {
 	
 	int currentapiVersion = android.os.Build.VERSION.SDK_INT;
 	AlertMsg amsg=null;
 	
 	if (!restore)
 	{
	 	if (currentapiVersion >= android.os.Build.VERSION_CODES.HONEYCOMB_MR1)
	 		amsg = UsbEnumHelper.SelectTypeUsb(context, spinnerDevice);
	 	else
	 		amsg = new AlertMsg("Error...", "Usb not avaialble for current API lavel...");
 	}
 	if ( amsg != null)
 		showAlertMsg(amsg.Title, amsg.Msg);
 }
 
    private void showAlertMsg(String title,String msg)
	{
    	AlertDialog.Builder dialogBuilder;    	
		dialogBuilder = new AlertDialog.Builder(context);    	
    	
		dialogBuilder.setNeutralButton( "OK", new DialogInterface.OnClickListener() 
		{			
			public void onClick(DialogInterface dialog, int which) {				
				dialog.dismiss();				
			}
		});
		
		dialogBuilder.setTitle(title);    	
		dialogBuilder.setMessage(msg);    	
		dialogBuilder.show();
    	
	}  
	
  

}

class CustomOnItemDeviceSelectedListener implements OnItemSelectedListener {
	 

	
	CustomOnItemDeviceSelectedListener()
	{
		super();		
		
	}
	
	  public void onItemSelected(AdapterView<?> parent, View view, int pos,long id) {
	
		  MainActivity.deviceSelected=pos;
	  }
	 
	  @Override
	  public void onNothingSelected(AdapterView<?> arg0) {
		// TODO Auto-generated method stub
	  }
	 
	 
	  
	}


class UsbEnumHelper
{
    public static  AlertMsg SelectTypeUsb(Context context, Spinner spinnerDevice)
    {
   	 
     int currentapiVersion = android.os.Build.VERSION.SDK_INT;
     AlertMsg amsg = null;
   	 try
   	 {
   	 	//Get the list of devices
   		 MainActivity.usbDeviceList = CustomAndroidAPI.EnumUsbDevices(context);
   	
   	 	if ((MainActivity.usbDeviceList == null) || (MainActivity.usbDeviceList.length == 0))
   	 	{
   	 		//Show Error
   	 		//showAlertMsg("Error...", "No Devices Connected...");            		
   	 		amsg = new AlertMsg("Error...", "No Devices Connected...");
   	 	}                               	
   	 }
   	 catch(CustomException e )
   	 {
   		MainActivity.usbDeviceList = null;
   	 	//Show Error
   	 	//showAlertMsg("Error...", e.getMessage());
   		amsg = new AlertMsg("Error...", e.getMessage());
   			
   	 }
   	 catch(Exception e )
   	 {
   		 MainActivity.usbDeviceList = null;
   	 	//Show Error
   	 	//showAlertMsg("Error...", "Enum devices error...");
   		amsg = new AlertMsg("Error...", e.getMessage());
   			
   	 }    
   	 
   	 String[] strDevices;
   	 
   	if (MainActivity.usbDeviceList == null)
   	{
   		strDevices = new String[0];
   	}
   	else
   	{
       	// Find the ListView resource.   
       	
         
           // Create and populate a List of Devices
           strDevices = new String[MainActivity.usbDeviceList.length];
           for (int i=0;i<MainActivity.usbDeviceList.length;i++)
           {
           	strDevices[i] = (i+1)+". USB Device";	
           	if (currentapiVersion >= android.os.Build.VERSION_CODES.HONEYCOMB_MR1)
           	{
           		strDevices[i] = (i+1)+". USB Device VID: 0x" +  IntToHexString(MainActivity.usbDeviceList[i].getVendorId(),4) + " PID: 0x"+IntToHexString(MainActivity.usbDeviceList[i].getProductId(),4);
           	}

           }
           

   	}
   	
       ArrayList<String> devicesList = new ArrayList<String>();  
       devicesList.addAll( Arrays.asList(strDevices) );  
     	
   		ArrayAdapter<String> dataAdapter = new ArrayAdapter<String>(context,android.R.layout.simple_spinner_item, devicesList);
     	dataAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);	  	
     	spinnerDevice.setAdapter(dataAdapter);
     	spinnerDevice.setOnItemSelectedListener(new CustomOnItemDeviceSelectedListener());
     	
     	
     return amsg;
    }
    
    private static String IntToHexString(int iValue, int num0chars) 
    {
    	
        String hexString;
        
        //convert to Hex
        hexString = Integer.toHexString(iValue);
        int num0towrite = num0chars - hexString.length();
        //If i need to add some "0" before
        if (num0towrite > 0)
        {
        	for (int i=0;i<num0towrite;i++)
        		hexString = "0" + hexString;
        }
        
        //Change to upper case
        hexString = hexString.toUpperCase();
        
        return hexString;    
    }   
}





