//************************************************************************************
//*                                                                                  *
//* This document contains programming examples.                                     *
//*                                                                                  *
//* Custom Engineering grants you a nonexclusive copyright license to use            *
//* all programming code examples from which you can generate similar                *
//* function tailored to your own specific needs.                                    *
//*                                                                                  *
//* All sample code is provided by Custom Engineering for illustrative purposes      *
//* only. These examples have not been thoroughly tested under all conditions.       *
//* Custom Engineering, therefore, cannot guarantee or imply reliability,            *
//* serviceability, or function of these programs.                                   *
//*                                                                                  *
//* In no event shall Custom Engineering be liable for any direct, indirect,         *
//* incidental, special, exemplary, or consequential damages (including, but not     *
//* limited to, procurement of substitute goods or services; loss of use, data,      *
//* or profits; or business interruption) however caused and on any theory of        *
//* liability, whether in contract, strict liability, or tort (including negligence  *
//* or otherwise) arising in any way out of the use of this software, even if        *
//* advised of the possibility of such damage.                                       *
//*                                                                                  *
//* All programs contained herein are provided to you "as is" without any            *
//* warranties of any kind.                                                          *
//* The implied warranties of non-infringement, merchantability and fitness for a    *
//* particular purpose are expressly disclaimed.                                     *
//*                                                                                  *
//************************************************************************************

package it.custom.powertool.demo.android.printtool;

import it.custom.powertool.api.android.*;
import java.io.File;
import java.util.ArrayList;
import java.util.List;
import android.content.Context;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.EditText;
import android.widget.Spinner;
import android.widget.AdapterView.OnItemSelectedListener;

 
public class CustomOnItemSelectedListener implements OnItemSelectedListener {
 
	private Context context;
	private Spinner spinnerParams;
	private EditText edText;
	public static boolean onRestore = false;
	public static int onRestoreCounter = 0;
	public static int onRestoreChildPos = -1;
	
	CustomOnItemSelectedListener(Context ctx, Spinner sp, EditText iView )
	{
		super();
		context = ctx;
		spinnerParams = sp;
		edText =iView;
		
	}
  public void onItemSelected(AdapterView<?> parent, View view, int pos,long id) {
	/*
	Toast.makeText(parent.getContext(), 
		"OnItemSelectedListener : " + parent.getItemAtPosition(pos).toString(),
		Toast.LENGTH_SHORT).show();
	*/
	  boolean restoring = false;
	  if ( onRestore)
	  {
		  restoring=true;
		  onRestoreCounter++;
		  if ( (onRestoreCounter>=2) || (pos==0))
		  {
			  onRestore=false;
			  onRestoreCounter=0;
		  }		  
	  }
	  
	edText.setText("");
	SetParamsFromProject(parent.getItemAtPosition(pos).toString(), restoring); 
	
	  if ( (restoring) && (!onRestore) && (onRestoreChildPos!=-1) )
		  spinnerParams.setSelection(onRestoreChildPos);
  }
 
  @Override
  public void onNothingSelected(AdapterView<?> arg0) {
	// TODO Auto-generated method stub
  }
 
  
  private void SetParamsFromProject(String prjname, boolean restore) {
  	
  	String prjdir, prjfile;
  	
  	if ( prjname == null)
  		return;
  	
  	prjdir = prjname;
  	prjfile = prjname;
  	
  	//Context context = getApplicationContext();
  	CustomStorage.CreateStorageDirectory();
  	

      
  	String XmlPrjfileName = CustomStorage.GetStorageDirectory() + "/" +  prjdir + "/" + prjfile + ".xml";
  	String XmlParamfileName = CustomStorage.GetStorageDirectory() + "/" +  prjdir + "/" + prjfile + ".param.xml";
      
  	File file = new File(XmlPrjfileName);
  	
  	if ( file.exists())
  	{  	    
  		try {
  			if ( !restore)
  			{
		  		CustomXmlAndroidAPI xmlparser = new CustomXmlAndroidAPI(context);
		    	xmlparser.SetXmlFileName(XmlPrjfileName);    	             
			    List<CustomXmlDictionaryItem> listParams = xmlparser.GetXmlTagValListFromParamFile(XmlParamfileName);
			    
			    if (listParams==null)
			    	listParams= new ArrayList<CustomXmlDictionaryItem>();
			    		    
			    addItemsOnSpinnerParams(listParams);  	
			    xmlparser=null;  	
			  	System.gc();
  			}
  			else
  			{
  				addItemsOnSpinnerParams(CustomOnItemParamsSelectedListener.listTagVal); 
  			}
  		}
  		catch (CustomXmlException e)
  		{
  	  		List<CustomXmlDictionaryItem> listempty = new ArrayList<CustomXmlDictionaryItem>();
  		    addItemsOnSpinnerParams(listempty); 
  		}
  	}
  	else
  	{
  		List<CustomXmlDictionaryItem> listempty = new ArrayList<CustomXmlDictionaryItem>();
	    addItemsOnSpinnerParams(listempty);  	
  	}
  	
  }
  
  
  public void addItemsOnSpinnerParams(List<CustomXmlDictionaryItem> listTV) 
  {
  	
		List<String> list = new ArrayList<String>();
		
		for (int i=0; i<listTV.size(); i++)
		{
			list.add(listTV.get(i).Tag);
		}
		
	
	  	if ( list.size() == 0)
	  		spinnerParams.setEnabled(false);
	  	else
	  		spinnerParams.setEnabled(true);
	  	
	  	ArrayAdapter<String> dataAdapter = new ArrayAdapter<String>(context,android.R.layout.simple_spinner_item, list);
	  	dataAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);	  	
	  	spinnerParams.setAdapter(dataAdapter);
	  	
	  	spinnerParams.setContentDescription("Select Params");
	  	spinnerParams.setOnItemSelectedListener(new CustomOnItemParamsSelectedListener(edText, listTV));
	  	

	  	
  }
  
}



class CustomOnItemParamsSelectedListener implements OnItemSelectedListener {
	 
	private EditText edText;
	public static List<CustomXmlDictionaryItem> listTagVal = null;
	public static int CurrentPos = -1;
	
	CustomOnItemParamsSelectedListener(EditText iView , List<CustomXmlDictionaryItem> listTV)
	{
		super();
		CurrentPos = -1;
		edText =iView;
		listTagVal = listTV;
		
	}
	
	  public void onItemSelected(AdapterView<?> parent, View view, int pos,long id) {
		  /*
			Toast.makeText(parent.getContext(), 
			"OnItemSelectedListener : " + parent.getItemAtPosition(pos).toString(),
			Toast.LENGTH_SHORT).show();
		   */		
		SetEditText(pos);
	  }
	 
	  @Override
	  public void onNothingSelected(AdapterView<?> arg0) {
		// TODO Auto-generated method stub
	  }
	 
	  private void SetEditText(int pos)
	  {
		  if ( (CurrentPos != -1) && (listTagVal!=null))
		  {
			  listTagVal.get(CurrentPos).Value = edText.getText().toString();
		  }
		  CurrentPos = pos;
		  String text =	listTagVal.get(pos).Value;
		  edText.setText(text);
	  }
	  
	  
	  public static void UpdateList(EditText eText)
	  {
		  if ( (CurrentPos != -1) && (listTagVal!=null))
		  {
			  listTagVal.get(CurrentPos).Value = eText.getText().toString();
		  }
	  }
	  
	}
