//************************************************************************************
//*                                                                                  *
//* This document contains programming examples.                                     *
//*                                                                                  *
//* Custom Engineering grants you a nonexclusive copyright license to use            *
//* all programming code examples from which you can generate similar                *
//* function tailored to your own specific needs.                                    *
//*                                                                                  *
//* All sample code is provided by Custom Engineering for illustrative purposes      *
//* only. These examples have not been thoroughly tested under all conditions.       *
//* Custom Engineering, therefore, cannot guarantee or imply reliability,            *
//* serviceability, or function of these programs.                                   *
//*                                                                                  *
//* In no event shall Custom Engineering be liable for any direct, indirect,         *
//* incidental, special, exemplary, or consequential damages (including, but not     *
//* limited to, procurement of substitute goods or services; loss of use, data,      *
//* or profits; or business interruption) however caused and on any theory of        *
//* liability, whether in contract, strict liability, or tort (including negligence  *
//* or otherwise) arising in any way out of the use of this software, even if        *
//* advised of the possibility of such damage.                                       *
//*                                                                                  *
//* All programs contained herein are provided to you "as is" without any            *
//* warranties of any kind.                                                          *
//* The implied warranties of non-infringement, merchantability and fitness for a    *
//* particular purpose are expressly disclaimed.                                     *
//*                                                                                  *
//************************************************************************************

package it.custom.powertool.demo.android.printtool;


import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import it.custom.powertool.demo.android.printtool.AlertMsg;
import it.custom.powertool.demo.android.printtool.CustomOnItemDevTypeSelectedListener;
import it.custom.powertool.demo.android.printtool.CustomOnItemParamsSelectedListener;
import it.custom.powertool.demo.android.printtool.CustomOnItemSelectedListener;
import it.custom.powertool.demo.android.printtool.R;
import it.custom.powertool.demo.android.printtool.UsbOpenHelper;


import it.custom.powertool.api.android.*;
import it.custom.printer.api.android.*;

import android.net.Uri;
import android.os.Bundle;
import android.os.Handler;
import android.os.Looper;
import android.os.Message;
import android.app.Activity;
import android.app.AlertDialog;
import android.app.ProgressDialog;
import android.bluetooth.BluetoothDevice;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.hardware.usb.UsbDevice;
import android.util.Log;
import android.view.Menu;
import android.view.View;
import android.view.WindowManager;
import android.widget.ArrayAdapter;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.Spinner;

public class MainActivity extends Activity {

	
    private ProgressDialog progressDialog=null;
    //private String galleryImageFile=null;
    private String mediaImageFile=null;
    private Bitmap myBitmap = null;
    private Spinner spinnerProject, spinnerParams, spinnerDevType, spinnerDevice;
	private final String FILENAME_RESULT = "customxmldata.png";   
	
	public static String[] ethDeviceList = null;	
	public static UsbDevice[] usbDeviceList = null;
	public static BluetoothDevice[] btDeviceList = null;
	
	public static int deviceSelected = -1;
	public static int deviceType = -1;
	
	static CustomPrinter prnDevice = null;	
	private String lock="lockAccess";
	
	public final int DEVTYPE_ETHERNET=1;
	public final int DEVTYPE_BLUETOOTH=2;
	public final int DEVTYPE_USB=3;
	private  Handler alertHandler;
	
	private static Activity ME=null;
	private int currentapiVersion=0;
	
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);
		
		InitEverything(savedInstanceState);
		
		if( savedInstanceState != null ) 
			loadMyData(savedInstanceState);
		     
	
		

	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.main, menu);
		return true;
	}
	    
    @Override
    public void onSaveInstanceState(Bundle outState) {
       super.onSaveInstanceState(outState);
       collectMyLoadedData(outState);
       
    }
    
    private void collectMyLoadedData(Bundle outState)
    {
    		
    	EditText edText = (EditText) findViewById(R.id.edit_message);    	
    	CustomOnItemParamsSelectedListener.UpdateList(edText);  
    	    	
    	outState.putString("imagepath", mediaImageFile);
    	outState.putInt("spindevicepos", spinnerDevice.getSelectedItemPosition());
    	outState.putInt("spinparamspos", spinnerParams.getSelectedItemPosition());
    	
    	CustomOnItemDevTypeSelectedListener.onRestore=true;
    	CustomOnItemDevTypeSelectedListener.onRestoreCounter=0;
    	CustomOnItemDevTypeSelectedListener.onRestoreChildPos=0;
    	CustomOnItemSelectedListener.onRestore=true;
    	CustomOnItemSelectedListener.onRestoreCounter=0;
    	CustomOnItemSelectedListener.onRestoreChildPos = -1;
    	
    }
    
    private void loadMyData(Bundle savedInstanceState)
    {    	
    	String imagePath = savedInstanceState.getString("imagepath");
    	if ( (imagePath!=null) && (imagePath.length()>0))
    	{
	    	File file = new File(imagePath);	       	  
	    	if(file.exists())
	        {
	           
	    	 myBitmap = BitmapFactory.decodeFile(file.getAbsolutePath());  
	    		
	           this.runOnUiThread(new Runnable() {
	        	    @Override
	        	    public void run() {
	        	    	 
	        	    	ImageView imgView = (ImageView) findViewById(R.id.myimage);  
	        	    	imgView.setImageBitmap(myBitmap);
	        	    	myBitmap=null;
	        	    }
	        	});
	           
	        }
	    	mediaImageFile = imagePath;
    	}    	
    	
    	CustomOnItemSelectedListener.onRestoreChildPos = savedInstanceState.getInt("spinparamspos");
    	CustomOnItemDevTypeSelectedListener.onRestoreChildPos = savedInstanceState.getInt("spindevicepos");
    	
    }	
	
    static class MyHandler extends Handler {
       
        @Override
        public void handleMessage(Message msg)
        {
	    	AlertMsg amsg = (AlertMsg)msg.obj;
	    	AlertDialog.Builder dialogBuilder;    	
			dialogBuilder = new AlertDialog.Builder(ME);    	
	    	
			dialogBuilder.setNeutralButton( "OK", new DialogInterface.OnClickListener() 
			{			
				public void onClick(DialogInterface dialog, int which) {				
					dialog.dismiss();				
				}
			});
			
			dialogBuilder.setTitle(amsg.Title);    	
			dialogBuilder.setMessage(amsg.Msg);    	
			dialogBuilder.show();
        }
    }
	
    
	private void InitEverything(Bundle savedInstanceState)
    {
		this.getWindow().setSoftInputMode(WindowManager.LayoutParams.SOFT_INPUT_STATE_ALWAYS_HIDDEN);
		
    	ME=this;
    	currentapiVersion = android.os.Build.VERSION.SDK_INT;
    	addItemsOnSpinnerProject();
    	addItemsOnSpinnerDevType();
    	CustomStorage.CreateStorageDirectory();
    	
    	alertHandler = new MyHandler();

    }
    


    
    /** Called when the user clicks the Preview button */
    public void button_preview_Click(View view) {
        // Do something in response to button
    	//start the progress dialog
    	
    	if ( spinnerProject.getSelectedItem().toString().equals("None"))
		{
    		showAlertMsg("Error...", "No Project Selected...");
    		return ;
		}
    	
    	if ((progressDialog!=null) && ( progressDialog.isShowing() ))
		{
    		showAlertMsg("Error...", "Application busy...");
    		return ;
		}
    			
    	
    	progressDialog = ProgressDialog.show(this, "Rendering", "Please wait...");    	
    	new Thread() {
	    	public void run() 
	    	{    		
	    		
		    	try{
		    		
		        	String name = spinnerProject.getSelectedItem().toString();
		        	Preview(name);
		    		
		    	} catch (Exception e) {
		    		Log.e("rwadXml error", e.getMessage());
		    	}
		    	// dismiss the progress dialog
		    	progressDialog.dismiss();
	    	}
    	}.start();
    	 
    	
    }
    

    
    private boolean printXml(String prjname, boolean preview) {
    	boolean printok = false;
    	int res;
    	String prjdir, prjfile;
    	
    	if (prjname == null) 
    		return printok;
    	
    	EditText edText = (EditText) findViewById(R.id.edit_message);
    	CustomOnItemParamsSelectedListener.UpdateList(edText);
    	
    	prjdir = prjname;
    	prjfile = prjname;
    	
    	Context context = getApplicationContext();
    	
    	
    
        File imgFileResult = new File(context.getFilesDir(), FILENAME_RESULT);
        
    	String XmlPrjfileName = CustomStorage.GetStorageDirectory() + "/" +  prjdir + "/" + prjfile + ".xml";
    	String XmlParamfileName = CustomStorage.GetStorageDirectory() + "/" +  prjdir + "/" + prjfile + ".param.xml";
        
    	File pfile = new File(XmlPrjfileName);
    	if ( !pfile.exists())
    	{
    		return printok;
    	}
    	
    	try {
    	
	    	CustomXmlAndroidAPI xmlparser = new CustomXmlAndroidAPI(this);
	    	
	    	String cptVersionString = xmlparser.GetAPIVersion();
	    		    		    	    	
	    	xmlparser.SetXmlFileName(XmlPrjfileName);    	
	                       
	        List<CustomXmlDictionaryItem> list = CustomOnItemParamsSelectedListener.listTagVal;
	        
	        if ( list == null)
	        {
	        	xmlparser.SetXmlObjectFromParamFile(XmlParamfileName);
	        }
	        else
	        {
		        for(int i=0; i<list.size();i++)
		        {
		        	xmlparser.SetXmlObjectTag(list.get(i).Tag, list.get(i).Value);
		        }
		        list=null;
	        }
	                	    	
	        if ( preview)
	        {	
	        	String antialiasStr="1";	        		        	
	        	
	        	res = xmlparser.SetXmlObjectTag("Canvas1.antialiasText", antialiasStr);
	        	res = xmlparser.SetXmlObjectTag("Canvas1.antialiasShape", antialiasStr);
	        		        		        	
		    	String info = xmlparser.GetXmlParsingErrors();
		    	if ( (info != null) && (info.length()>0))
		    		showAlertMsg("Xml Parsing Errors", info); 	    
		    	
		    	/*
		    	try
		    	{
		    		boolean is_res;
		    		is_res = xmlparser.GetXmlFontPropertyBold("Arial");
		    		is_res = xmlparser.GetXmlFontPropertyItalic("Arial");		    		
		    	}
		    	catch (Exception e)
		    	{
		    		
		    	}
		    	*/
		    	
		    	
		    	xmlparser.PreviewXml(imgFileResult.getAbsolutePath());
		    			    			    			    	
		    	
	        }
	        else
	        {	    
	        	//String antialiasStrText="2";
	        	//String antialiasStrShape="0";
	        	//res = xmlparser.SetXmlObjectTag("Canvas1.antialiasText", antialiasStrText);
	        	//res = xmlparser.SetXmlObjectTag("Canvas1.antialiasShape", antialiasStrShape);
	        	//xmlparser.PrintXml(prnDevice);
	        	String tmp1 = xmlparser.GetXmlObjectTag("Canvas1.antialiasText");
	        	String tmp2 = xmlparser.GetXmlObjectTag("Canvas1.antialiasShape");
	        	//xmlparser.PrintXml(prnDevice, CustomPrinter.IMAGE_ALIGN_TO_LEFT, CustomPrinter.IMAGE_SCALE_TO_FIT, 0);
	        	xmlparser.PrintXml(prnDevice, CustomPrinter.IMAGE_ALIGN_TO_LEFT, CustomPrinter.IMAGE_SCALE_NONE, 0);
	        }
	        
	    	xmlparser.Dispose();
	    	xmlparser = null;
	    	printok = true;
    	}
    	catch (CustomXmlException e)
    	{
    		showAlertMsg("Xml Error...", e.getMessage()); 
    	}
    	catch (CustomException e)
    	{
    		showAlertMsg("Print Error...", e.getMessage()); 
    	}
    	
    	
    	if ( preview)
    		managePreviewImage(imgFileResult);   	

    	
    	imgFileResult=null;
    	System.gc();
    	return printok;
    }
    
    
    private void managePreviewImage(File imgFileResult)
{
	File imgFileMediaResult = new File(CustomStorage.GetStorageMediaDirectory() + "/" + FILENAME_RESULT);
	try {
     	CustomFile.copy(imgFileResult, imgFileMediaResult) ;           
     }catch(IOException e){
     	e.printStackTrace();
     }
	
	mediaImageFile = imgFileMediaResult.getAbsolutePath();
	    	    	      
	   
	if(imgFileResult.exists())
    {
       
	 myBitmap = BitmapFactory.decodeFile(imgFileResult.getAbsolutePath());  
		
       this.runOnUiThread(new Runnable() {
    	    @Override
    	    public void run() {
    	    	 
    	    	ImageView imgView = (ImageView) findViewById(R.id.myimage);  
    	    	imgView.setImageBitmap(myBitmap);
    	    	myBitmap=null;
    	    }
    	});
       
    }    	
}
        
    
    // add items into spinner dynamically
    private void addItemsOnSpinnerDevType() 
    {
    	
    	
		List<String> list = new ArrayList<String>();
		list.add(getResources().getString(R.string.devtype_none));
		list.add(getResources().getString(R.string.devtype_ethernet));
		list.add(getResources().getString(R.string.devtype_bluetooth));
		
		if (currentapiVersion >= android.os.Build.VERSION_CODES.HONEYCOMB_MR1)
			list.add(getResources().getString(R.string.devtype_usb));
	   
	    spinnerDevType = (Spinner) findViewById(R.id.spinnerDevType);
	    spinnerDevice = (Spinner) findViewById(R.id.spinnerDevice);	  	  
	
	    MainActivity.deviceType=-1;
	  	ArrayAdapter<String> dataAdapter = new ArrayAdapter<String>(this, android.R.layout.simple_spinner_item, list);
	  	dataAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
	  	spinnerDevType.setAdapter(dataAdapter);  	
	  	spinnerDevType.setContentDescription(getResources().getString(R.string.select_devtype));  	
	  	spinnerDevType.setOnItemSelectedListener(new CustomOnItemDevTypeSelectedListener(this, spinnerDevice));  	
    }
    
    
 // add items into spinner dynamically
    private void addItemsOnSpinnerProject() {
    	
    	String filename, filepath;
    	List<String> list = new ArrayList<String>();
    	
    	File folder = new File(CustomStorage.GetStorageDirectory());

    	list.add("None");
    	
		if ( folder.exists()  && folder.isDirectory() )
		{
			File listfile[] = folder.listFiles();
			for (int i = 0; i < listfile.length; ++i) 
			{
				File fileInfo = listfile[i];
				filename = fileInfo.getName();
				filepath = fileInfo.getAbsolutePath();
				
				if ( !filepath.equals(CustomStorage.GetStorageMediaDirectory()))
				{
					list.add(filename);
				}
			}
		}
    	
   
	    spinnerProject = (Spinner) findViewById(R.id.spinnerProject);
	    spinnerParams = (Spinner) findViewById(R.id.spinnerParams);
	    EditText edText = (EditText) findViewById(R.id.edit_message);
	  	
	
	  	ArrayAdapter<String> dataAdapter = new ArrayAdapter<String>(this, android.R.layout.simple_spinner_item, list);
	  	dataAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
	  	spinnerProject.setAdapter(dataAdapter);
	  	
	  	spinnerProject.setContentDescription("Select Project");  	
	  	spinnerProject.setOnItemSelectedListener(new CustomOnItemSelectedListener(this, spinnerParams, edText));
	  	
	  	if ( list.size() == 0)
	  		spinnerProject.setEnabled(false);
	  	
	  	spinnerParams.setEnabled(false);
	  	
	   
    }
        
    
    public void Image_Click(View view) {
    
    	if ( mediaImageFile != null)
    	{    		    		     
	    	Intent intent = new Intent();
	    	intent.setAction(Intent.ACTION_VIEW);
	    	String filename= "file://" + mediaImageFile;
	    	intent.setDataAndType(Uri.parse(filename), "image/*");	    	    	
	    	startActivity(intent);    	
    	}
    	
    }
    
    
    public void button_print_Click(View view)
	{  
    	
    	if ( spinnerProject.getSelectedItem().toString().equals("None"))
		{
    		showAlertMsg("Error...", "No Project Selected...");
    		return ;
		}
    	//Device not selected
    	if (deviceSelected == -1)
    	{
    		showAlertMsg("Error...", "No Printer Device Selected...");
    		return ;
    	}
    	
    	if ( (deviceType <1) || (deviceType >3))
    	{
    		showAlertMsg("Error...", "No Printer Device Type Selected...");
    		return ;
    	}

    	if ((progressDialog!=null) && ( progressDialog.isShowing() ))
		{
    		showAlertMsg("Error...", "Application busy...");
    		return ;
		}    	
    	
    	progressDialog = ProgressDialog.show(this, "Printing", "Please wait...");    	
    	new Thread() {
	    	public void run() 
	    	{    			    		
	    		
		    	try{
		    		Looper.prepare();
		        	String name = spinnerProject.getSelectedItem().toString();		        	
		        	Print(name);
		    		
		    	} catch (Exception e) {
		    		Log.e("Printing error", e.getMessage());
		    	}		    
	    		
		    	// dismiss the progress dialog
		    	progressDialog.dismiss();
	    	}
    	}.start();	
	
	
	
	}
    
    private void Preview(String prjname)
    {
    	if ((prjname == null) || (prjname.length()==0) )
    	{
    		showAlertMsg("Error...", "Invalid Project to Preview...");
    		return;
    	}
       	synchronized (lock) 
		{
       		boolean preview = true;
       		printXml(prjname, preview);
		}
    	
    }
    
    private void Print(String prjname)
    {
    	boolean printOK = false;
    	if ((prjname == null) || (prjname.length()==0) )
    	{
    		showAlertMsg("Error...", "Invalid Project to Print...");
    		return;
    	}
    	
    	//open device
    	if (OpenDevice() == false)
    		return;   
	    	
	    synchronized (lock) 
		{
		    	         	    		    	
    		//***************************************************************************
    		// PRINT PICTURE
    		//***************************************************************************
    		
	    	try
	        {
	    		boolean preview=false;
	    		printOK = printXml(prjname, preview);	    			    	
	        }
			catch(Exception e )
	        {
				showAlertMsg("Error...", "Print Xml Error...");
	        }
			
			//***************************************************************************
			// FEEDS and CUT
			//***************************************************************************
			
			try
	        {
				if (printOK)
				{
					//Feeds (3)
					prnDevice.feed(3);
		    		//Cut (Total)
		    		prnDevice.cut(CustomPrinter.CUT_TOTAL);	   
				}
	        }
	    	catch(CustomException e )
            {    
	    		//Only if isn't unsupported
	    		if (e.GetErrorCode() != CustomException.ERR_UNSUPPORTEDFUNCTION)
	    		{
	    			//Show Error
	    			showAlertMsg("Error...", e.getMessage());
	    		}
            }
			catch(Exception e )
	        {
				showAlertMsg("Error...", "Print Error...");
	        }
			
			//***************************************************************************
			// PRESENT
			//***************************************************************************
			
			try
	        {				
	    		//Present (40mm)
	    		prnDevice.present(40);
	        }
	    	catch(CustomException e )
            {    
	    		//Only if isn't unsupported
	    		if (e.GetErrorCode() != CustomException.ERR_UNSUPPORTEDFUNCTION)
	    		{
	    			//Show Error
	    			showAlertMsg("Error...", e.getMessage());
	    		}
            }
			catch(Exception e )
	        {
				showAlertMsg("Error...", "Print Error...");
	        }
			
			CloseDevice();
		}
	} 
    
    
    private boolean CloseDevice()
    {
    	
		if (prnDevice != null)
		{
			try
            {
				//Force close
				if ( prnDevice!= null)
					prnDevice.close();
            }
			catch(CustomException e )
            {
            	
            	//Show Error
            	showAlertMsg("Error...", e.getMessage());
        		return false;
            }
			catch(Exception e )
            {
    			//Show error
    			return false;
            }
			prnDevice = null;
		}
		return true;
    }
    
    //Open the device if it isn't already opened
    private boolean OpenDevice()
    {
    	
    	
    	//Device not selected
    	if (deviceSelected == -1)
    	{
    		showAlertMsg("Error...", "No Printer Device Selected...");
    		return false;
    	}
    	
    	if ( (deviceType <1) || (deviceType >3))
    	{
    		showAlertMsg("Error...", "No Printer Device Type Selected...");
    		return false;
    	}
    	

		if (prnDevice != null)
			 CloseDevice();

    	//If i never open it
    	if (prnDevice == null)
    	{
    		try
            {    	
    			//Open and connect it   
    			if ( deviceType== DEVTYPE_ETHERNET) 
    			{
    				prnDevice = new CustomAndroidAPI().getPrinterDriverETH(ethDeviceList[deviceSelected], 9100);
    			}
    			else if ( deviceType== DEVTYPE_BLUETOOTH)
    			{
    				prnDevice = new CustomAndroidAPI().getPrinterDriverBT(btDeviceList[deviceSelected]);
    			}
    			else if ( deviceType== DEVTYPE_USB)
    			{
    				if (currentapiVersion >= android.os.Build.VERSION_CODES.HONEYCOMB_MR1)
    					prnDevice = UsbOpenHelper.openUsbDeviceSelected(this);
    				else
    					prnDevice = null;
    				//prnDevice = new CustomAndroidAPI().getPrinterDriverUSB(usbDeviceList[deviceSelected], this);
    			}
    			else
    			{
    	    		showAlertMsg("Error...", "No Printer Device Type Selected...");
    	    		return false;
    			}
    			//Save last device selected    			
    			return true;
            }
    		catch(CustomException e )
            {
            	
            	//Show Error
            	showAlertMsg("Error...", e.getMessage());
        		return false;
            }
    		catch(Exception e )
            {
    			showAlertMsg("Error...", "Open Print Error...");
    			//open error
    			return false;
            }
    	}
    	
    	
    	//Already opened
    	return true;
    	
    }    
   
        
    private void showAlertMsg(String title,String msg)
	{

    		Message amsg = new Message();
    		amsg.obj = new AlertMsg(title, msg);    		
	    	alertHandler.sendMessage(amsg);
	    	return  ;
	    	    
	}  
    	
	

}



class AlertMsg
{
	public String Title;
	public String Msg;
	
	public AlertMsg (String title, String msg)
	{
		Title=title;
		Msg=msg;
	}
}



class UsbOpenHelper
{
	
    public  static CustomPrinter openUsbDeviceSelected(Context context) throws CustomException
    {
    	return new CustomAndroidAPI().getPrinterDriverUSB(MainActivity.usbDeviceList[MainActivity.deviceSelected], context);
    }
    
}

