#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<pthread.h>
#include "CustomXmlPrint.h"

extern char ** GetAvailablePrinters(int * len);

void test_XmlToImg(char * xmlfileName, char * xmlParamfileName, int id)
{
		int useDialog=0;
		void * handle;
		int i, len;
		char ** printerList;
		char ** fontList;
		char ** pageSizeList;
		CustomXmlPrintResult result;
		char value[1024];
		char selectedPrinter[256];
	
                printerList = GetAvailablePrinters(&len);
		for(i=0; i<len; i++)
			printf("printerList[%d]=%s\n", i, printerList[i]);
		if ( strcmp(xmlfileName, "printers")==0 )
			exit(0);

		// EDIT ACCORDING TO SYSTEM SETTINGS
		strcpy(selectedPrinter, printerList[id]);
		FreeInfoPtrMemory(printerList, len);
		
		if ( useDialog )
			handle = GetXmlPrintHandleFromDialog();
		else
		{
			//handle = GetXmlPrintHandle("VKP80-");
			handle = GetXmlPrintHandle(selectedPrinter);
#if 0
                	result = SetMarginsMM( handle, 0 * 100, 0 * 100, 0 * 100, 0 * 100);
			pageSizeList = GetPageSizeNames(handle, &len);
			for(i=0; i<len; i++)
				printf("pageSizeList[%d]=%s\n", i, pageSizeList[i]);

			// EDIT ACCORDING TO SYSTEM SETTINGS
                	result = SetPageSizeName(handle, pageSizeList[3]);
			FreeInfoPtrMemory(pageSizeList, len);
#else
                	result = SetPageSizeMM(handle, 80 * 100, 160 * 100);
#endif
                	result = SetOrientation(handle, CUSTOM_ORIENTATION_PORTRAIT);
		}
#if 0
                fontList = GetXmlAvailableFontList(handle, &len);
		for(i=0; i<len; i++)
			printf("fontList[%d]=%s\n", i, fontList[i]);
		FreeInfoPtrMemory(fontList, len);
#endif

                result = SetXmlFileName(handle, xmlfileName);
#if 0

                result = SetXmlTag(handle, "tag1", "rect1.png");
                result = SetXmlTag(handle, "tag2", "rect2.jpg");
                result = SetXmlObjectTag(handle, "image3.filepath", "image2.bmp");
                result = SetXmlObjectTag(handle, "image4.filepath", "image3.bmp");
		bzero(value,1024);
		result = GetXmlObjectTag(handle, "image4.filepath", value,1024);
		printf("Get vale for image4.filepath ret=%d value=%s\n", result, value);

		result = SetXmlObjectTag(handle, "textSEAT_NUM.text","40");
		result = SetXmlObjectTag(handle, "textROW_NUM.text","C");
		result = SetXmlObjectTag(handle, "textBLOCK_NUM.text","C3");
		result = SetXmlObjectTag(handle, "textENTRANCE_NUM.text","D");

#endif

		if ( (xmlParamfileName!= NULL) && (strlen(xmlParamfileName) > 0) )
		{
			int idx;
			char * ptr;
			char * strptr;
			char tagbuf[2048];
			char valbuf[2048];
			char buf[1024];
			result = GetXmlObjectsFromParamFile(handle, xmlParamfileName, tagbuf, 2048, valbuf, 2048);
			printf("GetXmlObjectsFromParamFile result=%d\n", result);
				
			printf("TAG VALUES\n");
			strptr = tagbuf;
			while (	(ptr=strchr(strptr, CUSTOM_XMLPRINT_SEPARATOR))	!= NULL )
			{
				strncpy(buf, strptr, ptr - strptr);
				buf[ptr - strptr]=0;
				printf("%s\n", buf);
				strptr = ptr+1;
			}
			strcpy(buf, strptr);
			printf("%s\n", buf);
	
			printf("VAL VALUES\n");
			strptr = valbuf;
			while (	(ptr=strchr(strptr, CUSTOM_XMLPRINT_SEPARATOR))	!= NULL )
			{
				strncpy(buf, strptr, ptr - strptr);
				buf[ptr - strptr]=0;
				printf("%s\n", buf);
				strptr = ptr+1;
			}
			strcpy(buf, strptr);
			printf("%s\n", buf);

		}
		if ( (xmlParamfileName!= NULL) && (strlen(xmlParamfileName) > 0) )
		{
			result = SetXmlObjectsFromParamFile(handle, xmlParamfileName);
			printf("SetXmlObjectsFromParamFile result=%d\n", result);
		}
		if ( 1)
		{
			char info[2048];
			bzero(info,2048);
       		        result = GetXmlCheckCorrectParsing(handle, info,2048);
			printf("\n\nGetXmlCheckCorrectParsing result=%d\nINFO:\n%s\nEND\n", result, info);

			//return;
		}
                result = PrintXml(handle, 1);
                result = FreeXmlPrintHandle(handle);
}


int main(int argc, char ** argv)
{
	char libver[128];
	int id = 0;

	GetLibraryApiVersion(libver, 128);
	printf("Library version = %s\n", libver);
	if ( argc < 2 )
	{
		printf("Usage %s <xml file>  <xml param file> <printer id in list>\n", argv[0]);
		printf("Usage %s printers\n", argv[0]);
		return 0;
	}

	if ( argc > 3 )
		id = atoi(argv[3]);
	
	printf("argc=%d argv[1]=%s argv[2]=%s id=%d\n", argc, argv[1], argv[2], id);
	test_XmlToImg(argv[1], argv[2] , id);

	return 0;
}
