/*
    * This document contains programming examples.
    * 
    * Custom Engineering grants you a nonexclusive copyright license to use all programming code examples from which you can generate similar function tailored to your own specific needs.
    * 
    * All sample code is provided by Custom Engineering for illustrative purposes only. These examples have not been thoroughly tested under all conditions. 
    * Custom Engineering, therefore, cannot guarantee or imply reliability, serviceability, or function of these programs.
    * 
    * In no event shall Custom Engineering be liable for any direct, indirect, incidental, special, exemplary, or consequential damages (including, but not limited to, procurement of substitute goods or services; loss of use, data, or profits; or business interruption) however caused and on any theory of liability, whether in contract, strict liability, or tort 
    * (including negligence or otherwise) arising in any way out of the use of this software, even if advised of the possibility of such damage.
    * 
    * All programs contained herein are provided to you "as is" without any warranties of any kind.
    * The implied warranties of non-infringement, merchantability and fitness for a particular purpose are expressly disclaimed.
    *  
    */
#include "InputDialog.h"
#include "CustomXmlPrint.h"
#include <unistd.h>

#include <QFileDialog>
#include <QMessageBox>

 InputDialog::InputDialog(QWidget *parent, QApplication * qa)
     //: QDialog(parent, Qt::FramelessWindowHint)
 {
        m_qapp = qa;
        setupUi(this);
        ConnectObjects();
        //move(0,0);
 }


void InputDialog::ConnectObjects()
{

        connect(pushButtonPrint, SIGNAL(clicked()), this, SLOT(buttonPrintPressed()));
 	connect(pushButtonPrintMacro, SIGNAL(clicked()), this, SLOT(buttonPrintMacroPressed()));
	connect(pushButtonClose, SIGNAL(clicked()), this, SLOT(buttonClosePressed()));
	connect(pushButtonSelect, SIGNAL(clicked()), this, SLOT(buttonSelectPressed()));
	connect(pushButtonParam, SIGNAL(clicked()), this, SLOT(buttonParamPressed()));

}

void InputDialog::buttonSelectPressed()
{
	QString fileName = QFileDialog::getOpenFileName(this,tr("Open Xml file"), "/", tr("Xml Files (*.xml)"));
	lineEdit->setText(fileName);
}

void InputDialog::buttonParamPressed()
{
	QString fileName = QFileDialog::getOpenFileName(this,tr("Open Xml file"), "/", tr("Xml Files (*.xml)"));
	lineEdit_Param->setText(fileName);
}

void InputDialog::buttonClosePressed()
{
	exit(0);
}

void InputDialog::buttonPrintMacroPressed()
{

	int useDialog=0;
	void * handle;
	int i, len;
	char ** printerList;
	char ** fontList;
	CustomXmlPrintResult result;
	char xmlfilename[256];
	int selectedPrinter,idxPrinting, printingCounter=0;

	strcpy(xmlfilename, "/mnt/shared/__DIRECTPRINT/CustomXmlPrintEliminaCode/CustomXmlPrintEliminaCode.xml");

	printerList = GetAvailablePrinters(&len);
	for(i=0; i<len; i++)
		printf("printerList[%d]=%s\n", i, printerList[i]);

selectedPrinter=0;
printingCounter=12;
for(idxPrinting=0; idxPrinting<printingCounter; idxPrinting++)
{

	if ( idxPrinting ==  6 )
	{
		int secs=32;
		printf("DO SLEEP %d secs ...\n", secs);
		sleep(secs);
	}

	if ((idxPrinting!=0) &&( (idxPrinting%2) == 0))
	{
		if ( selectedPrinter == 0)
			selectedPrinter = 1;
		else if ( selectedPrinter == 1)
			selectedPrinter = 2;
		else
			selectedPrinter = 0;
	}
	printf("selectedPrinter=%d\n", selectedPrinter);

	if ( useDialog )
		handle = GetXmlPrintHandleFromDialog();
	else
	{
		if ( selectedPrinter == 0 )
		{	
		handle = GetXmlPrintHandle("KUBE2-SERIAL");
		}
		else if ( selectedPrinter == 1 )
		{
		handle = GetXmlPrintHandle("KUBE2-USB");
		}
		else
		{
		handle = GetXmlPrintHandle("KUBE2-ETH");
		}
		
		result = SetMarginsMM( handle, 0 * 100, 0 * 100, 0 * 100, 0 * 100);
		//result = SetPageSizeMM(handle, 80 * 100, 160 * 100);
		//result = SetOrientation(handle, CUSTOM_ORIENTATION_PORTRAIT);
		result = SetPageSizeName(handle, "X80MMYRoll");
		printf("SetPageSizeName result=%d\n", result);
		result = SetNumCopies(handle, 1);

	}

	fontList = GetXmlAvailableFontList(handle, &len);

#if 0
	for(i=0; i<len; i++)
		printf("fontList[%d]=%s\n", i, fontList[i]);
#endif


	result = SetXmlFileName(handle,xmlfilename);
	printf("SetXmlFileName result=%d\n", result);

/*
	result = SetXmlObjectTag(handle, "textSEAT_NUM.text","40");
	result = SetXmlObjectTag(handle, "textROW_NUM.text","C");
	result = SetXmlObjectTag(handle, "textBLOCK_NUM.text","C3");
	result = SetXmlObjectTag(handle, "textENTRANCE_NUM.text","D");


	result = SetXmlObjectTag(handle, "TextBoxRep.fontname","DejaVu Sans Mono");
	result = SetXmlObjectTag(handle, "TextBoxEuro.fontname","DejaVu Sans Mono");
	result = SetXmlObjectTag(handle, "TextBoxTotal.fontname","DejaVu Sans Mono");
	result = SetXmlObjectTag(handle, "TextBoxTotalValue.fontname","DejaVu Sans Mono");
	result = SetXmlObjectTag(handle, "TextBoxContanti.fontname","DejaVu Sans Mono");
	result = SetXmlObjectTag(handle, "TextBoxContantiValue.fontname","DejaVu Sans Mono");
	result = SetXmlObjectTag(handle, "TextBoxPrice.fontname","DejaVu Sans Mono");
	result = SetXmlObjectTag(handle, "TextBoxProdotti.fontname","DejaVu Sans Mono");
	result = SetXmlObjectTag(handle, "TextBoxProdottiValue.fontname","DejaVu Sans Mono");

	result = SetXmlObjectTag(handle, "TextBoxTotalValue.text","33.99");
	result = SetXmlObjectTag(handle, "TextBoxContantiValue.text","47.00");
	result = SetXmlObjectTag(handle, "TextBoxProdottiValue.text","25");
	result = SetXmlObjectTag(handle, "TextBoxRep.text","REP31\nREP42\nREP53\nREP64\nREP75");
	result = SetXmlObjectTag(handle, "TextBoxPrice.text","99,00\n88,00\n111,00\n11,00\n22,00");
	result = SetXmlObjectTag(handle, "BarcodeFinal.text","1928374650");
	if ( (paramFileName != NULL) && (paramFileName.length() >0) )
	{
		result = SetXmlObjectsFromParamFile(handle, paramFileName.toLatin1().data());
		printf("SetXmlObjectsFromParamFile result=%d\n", result);

	}

*/
	result = PrintXml(handle, 0);
	printf("******** ######## ******** PrintXml result=%d\n", result);

	if ( result != 0 )
	{
		 char errorStr[128];
		 sprintf(errorStr, "Error Code %d\n", result); 
		 QMessageBox::warning(this, "Printing Error", errorStr, QMessageBox::Ok);
	}

	result = FreeXmlPrintHandle(handle);
}

}

#if 0
void InputDialog::buttonPrintPressed()
{
	int useDialog=1;
	void * handle;
	int i, len;
	char ** printerList;
	char ** fontList;
	CustomXmlPrintResult result;

	QString xmFileName = lineEdit->text();
	QString paramFileName = lineEdit_Param->text();

	printerList = GetAvailablePrinters(&len);
	for(i=0; i<len; i++)
		printf("printerList[%d]=%s\n", i, printerList[i]);

		handle = GetXmlPrintHandle("CUSTOM_Engineering_VK80");

	fontList = GetXmlAvailableFontList(handle, &len);

#if 0
	for(i=0; i<len; i++)
		printf("fontList[%d]=%s\n", i, fontList[i]);
#endif
{
	char fontname[256];
	int bold, italic;

	printf("FONT PROP BEFORE\n");

	strcpy(fontname, "Arial");
	result = GetXmlFontProperty(handle, fontname, &bold, &italic);
	printf("GetXmlFontProperty result=%d font=%s bold=%d italic=%d\n", result, fontname, bold, italic);

	strcpy(fontname, "KaiTi");
	result = GetXmlFontProperty(handle, fontname, &bold, &italic);
	printf("GetXmlFontProperty result=%d font=%s bold=%d italic=%d\n", result, fontname, bold, italic);
}


	result = SetXmlFileName(handle, xmFileName.toLatin1().data());
	printf("SetXmlFileName result=%d\n", result);

{
	char fontname[256];
	int bold, italic;
	printf("FONT PROP AFTER\n");

	strcpy(fontname, "Arial");
	result = GetXmlFontProperty(handle, fontname, &bold, &italic);
	printf("GetXmlFontProperty result=%d font=%s bold=%d italic=%d\n", result, fontname, bold, italic);

	strcpy(fontname, "KaiTi");
	result = GetXmlFontProperty(handle, fontname, &bold, &italic);
	printf("GetXmlFontProperty result=%d font=%s bold=%d italic=%d\n", result, fontname, bold, italic);
}

	result = FreeXmlPrintHandle(handle);

	
}
#else
void InputDialog::buttonPrintPressed()
{
	int useDialog=1;
	void * handle;
	int i, len;
	char ** printerList;
	char ** fontList;
	CustomXmlPrintResult result;

	QString xmFileName = lineEdit->text();
	QString paramFileName = lineEdit_Param->text();

	printerList = GetAvailablePrinters(&len);
	for(i=0; i<len; i++)
		printf("printerList[%d]=%s\n", i, printerList[i]);

	if ( useDialog )
		handle = GetXmlPrintHandleFromDialog();
	else
	{
		handle = GetXmlPrintHandle("VKP80-");
		result = SetMarginsMM( handle, 0 * 100, 0 * 100, 0 * 100, 0 * 100);
		result = SetPageSizeMM(handle, 80 * 100, 160 * 100);
		result = SetOrientation(handle, CUSTOM_ORIENTATION_PORTRAIT);
		result = SetNumCopies(handle, 1);

	}

	fontList = GetXmlAvailableFontList(handle, &len);

#if 0
	for(i=0; i<len; i++)
		printf("fontList[%d]=%s\n", i, fontList[i]);
#endif


	result = SetXmlFileName(handle, xmFileName.toLatin1().data());
	printf("SetXmlFileName result=%d\n", result);

/*
	result = SetXmlObjectTag(handle, "textSEAT_NUM.text","40");
	result = SetXmlObjectTag(handle, "textROW_NUM.text","C");
	result = SetXmlObjectTag(handle, "textBLOCK_NUM.text","C3");
	result = SetXmlObjectTag(handle, "textENTRANCE_NUM.text","D");


	result = SetXmlObjectTag(handle, "TextBoxRep.fontname","DejaVu Sans Mono");
	result = SetXmlObjectTag(handle, "TextBoxEuro.fontname","DejaVu Sans Mono");
	result = SetXmlObjectTag(handle, "TextBoxTotal.fontname","DejaVu Sans Mono");
	result = SetXmlObjectTag(handle, "TextBoxTotalValue.fontname","DejaVu Sans Mono");
	result = SetXmlObjectTag(handle, "TextBoxContanti.fontname","DejaVu Sans Mono");
	result = SetXmlObjectTag(handle, "TextBoxContantiValue.fontname","DejaVu Sans Mono");
	result = SetXmlObjectTag(handle, "TextBoxPrice.fontname","DejaVu Sans Mono");
	result = SetXmlObjectTag(handle, "TextBoxProdotti.fontname","DejaVu Sans Mono");
	result = SetXmlObjectTag(handle, "TextBoxProdottiValue.fontname","DejaVu Sans Mono");

	result = SetXmlObjectTag(handle, "TextBoxTotalValue.text","33.99");
	result = SetXmlObjectTag(handle, "TextBoxContantiValue.text","47.00");
	result = SetXmlObjectTag(handle, "TextBoxProdottiValue.text","25");
	result = SetXmlObjectTag(handle, "TextBoxRep.text","REP31\nREP42\nREP53\nREP64\nREP75");
	result = SetXmlObjectTag(handle, "TextBoxPrice.text","99,00\n88,00\n111,00\n11,00\n22,00");
	result = SetXmlObjectTag(handle, "BarcodeFinal.text","1928374650");
*/
	if ( (paramFileName != NULL) && (paramFileName.length() >0) )
	{
		result = SetXmlObjectsFromParamFile(handle, paramFileName.toLatin1().data());
		printf("SetXmlObjectsFromParamFile result=%d\n", result);

	}

	result = PrintXml(handle, 0);
	printf("PrintXml result=%d\n", result);
	result = FreeXmlPrintHandle(handle);

	
}

#endif

